using System.Runtime.Serialization;
using System.Collections.Generic;

namespace Ato.EN.IntegrationServices.CodeGenerationIITRPRFL2022
{
    /// <summary>
    /// IITRPRFL
    /// </summary>
    [DataContract(Name = "IITRPRFL", Namespace = "http://www.sbr.gov.au/ato/iitrprfl")]
    public class IITRPRFL
    {

        [DataMember(EmitDefaultValue = false, Order = 1)]
        public Rp Rp { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 2)]
        public Int Int { get; set; }
    }
    
    [CollectionDataContract(Name = "ProfileCompareAssessmentTypeCCollection", Namespace = "http://www.sbr.gov.au/ato/iitrprfl", ItemName="ProfileCompareAssessmentTypeC")]
    public class ProfileCompareAssessmentTypeCCollection: List<string> {}

    /// <summary>
    /// Occupation
    /// </summary>
    [DataContract(Name = "PersonDemographicDetailsOccupation", Namespace = "http://www.sbr.gov.au/ato/iitrprfl")]
    public class PersonDemographicDetailsOccupation
    {

        /// <summary>
        /// Main salary or wage occupation description
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public string De { get; set; }

        /// <summary>
        /// Occupation code
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public string C { get; set; }
    }

    /// <summary>
    /// Payer
    /// </summary>
    [CollectionDataContract(Name = "PayerCollection", Namespace = "http://www.sbr.gov.au/ato/iitrprfl", ItemName="Payer" )]
    public class PayerCollection: List<Payer> {}

    /// <summary>
    /// Payer
    /// </summary>
    [DataContract(Name = "Payer", Namespace = "http://www.sbr.gov.au/ato/iitrprfl")]
    public class Payer
    {

        /// <summary>
        /// Payer's Australian Business Number (ABN)
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public string AustralianBusinessNumberId { get; set; }

        /// <summary>
        /// Payer's Withholder Payer Number (WPN)
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public string WithholdingPayerNumberId { get; set; }

        /// <summary>
        /// Salary and Wages Gross income
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public decimal SalaryOrWagesA { get; set; }
    }

    /// <summary>
    /// Income Tax Deduction
    /// </summary>
    [DataContract(Name = "IncomeTaxDeduction", Namespace = "http://www.sbr.gov.au/ato/iitrprfl")]
    public class IncomeTaxDeduction
    {

        /// <summary>
        /// Work related car expenses
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public decimal? CarA { get; set; }

        /// <summary>
        /// Work related travel expenses
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public decimal? TravelA { get; set; }

        /// <summary>
        /// Work related uniform, occupation specific or protective clothing, laundry and dry cleaning expenses
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public decimal? ClothingA { get; set; }

        /// <summary>
        /// Work related self-education expenses
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 4)]
        public decimal? EducationA { get; set; }

        /// <summary>
        /// Other work related expenses
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 5)]
        public decimal? WorkRelatedOtherA { get; set; }

        /// <summary>
        /// Total Other deductions
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 6)]
        public decimal? UncategorisedOtherA { get; set; }

        /// <summary>
        /// Cost of managing tax affairs - Other expenses
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 7)]
        public decimal? TaxAffairManagementOtherA { get; set; }

        /// <summary>
        /// Rent - Gross rent
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 8)]
        public decimal? RealEstatePropertyRentalA { get; set; }

        /// <summary>
        /// Rent - Interest deductions
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 9)]
        public decimal? RentalIncomeInterestDeductionsA { get; set; }

        /// <summary>
        /// Rent - Capital works deductions
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 10)]
        public decimal? CapitalWorksDeductionsA { get; set; }

        /// <summary>
        /// Rent - Other rental deductions
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 11)]
        public decimal? RentalIncomeDeductionsOtherThanInterestAndCapitalWorksA { get; set; }

        /// <summary>
        /// Rent - Number of properties
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 12)]
        public decimal? RealEstatePropertyPropertiesCt { get; set; }
    }

    /// <summary>
    /// Sole Trader Assessment
    /// </summary>
    [DataContract(Name = "SoleTrader", Namespace = "http://www.sbr.gov.au/ato/iitrprfl")]
    public class SoleTrader
    {

        /// <summary>
        /// Sole trader - Description of main business or professional activity
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public string OrganisationDetailsMainIncomeActivityDe { get; set; }

        /// <summary>
        /// Sole trader - Industry code of main business
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public string OrganisationDetailsOrganisationIndustry2006ExtendedC { get; set; }

        /// <summary>
        /// Sole trader - Postcode of main business address
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public string AddressDetailsPostcodeT { get; set; }

        /// <summary>
        /// Sole trader - Business name of main business
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 4)]
        public string OrganisationNameDetailsOrganisationalNameT { get; set; }

        /// <summary>
        /// Sole trader - Australian Business Number (ABN)
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 5)]
        public string AustralianBusinessNumberId { get; set; }

        /// <summary>
        /// Sole trader - Total business income
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 6)]
        public decimal BusinessGrossTotalA { get; set; }

        /// <summary>
        /// Sole trader - Total business expenses
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 7)]
        public decimal ExpenseOperatingBusinessTotalA { get; set; }

        /// <summary>
        /// Sole trader - Total expense reconciliation adjustments
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 8)]
        public decimal ExpenseReconciliationAdjustmentTotalA { get; set; }

        /// <summary>
        /// Sole trader - Payments to associated persons
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 9)]
        public decimal RemunerationPaymentToRelatedPartiesGrossA { get; set; }
    }

    /// <summary>
    /// Income
    /// </summary>
    [DataContract(Name = "Income", Namespace = "http://www.sbr.gov.au/ato/iitrprfl")]
    public class Income
    {

        [DataMember(EmitDefaultValue = false, Order = 1)]
        public PayerCollection PayerCollection { get; set; }

        /// <summary>
        /// Amount of allowances, earnings, tips, director's fees, etc
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public decimal? AllowancesEarningsTipsDirectorsFeesA { get; set; }

        /// <summary>
        /// Total Reportable Fringe Benefits amount
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public decimal? FringeBenefitsReportableA { get; set; }

        /// <summary>
        /// Gross interest
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 4)]
        public decimal? InterestGrossA { get; set; }

        /// <summary>
        /// Dividends - Unfranked amount
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 5)]
        public decimal? DividendsUnfrankedA { get; set; }

        /// <summary>
        /// Dividends - Franked amount
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 6)]
        public decimal? DividendsFrankedA { get; set; }

        /// <summary>
        /// Dividends - Franking credit
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 7)]
        public decimal? TaxFrankingCreditsA { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 8)]
        public IncomeTaxDeduction IncomeTaxDeduction { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 9)]
        public SoleTrader SoleTrader { get; set; }
    }

    /// <summary>
    /// Reporting Party
    /// </summary>
    [DataContract(Name = "Rp", Namespace = "http://www.sbr.gov.au/ato/iitrprfl")]
    public class Rp
    {

        /// <summary>
        /// Year of return
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public int TargetFinancialY { get; set; }

        /// <summary>
        /// Tax File Number (TFN)
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public string TaxFileNumberId { get; set; }

        /// <summary>
        /// Profile Compare Assessment Type
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public ProfileCompareAssessmentTypeCCollection ProfileCompareAssessmentTypeCCollection { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 4)]
        public PersonDemographicDetailsOccupation PersonDemographicDetailsOccupation { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 5)]
        public Income Income { get; set; }
    }

    /// <summary>
    /// Intermediary
    /// </summary>
    [DataContract(Name = "Int", Namespace = "http://www.sbr.gov.au/ato/iitrprfl")]
    public class Int
    {

        /// <summary>
        /// Tax Agent's Australian Business Number (ABN)
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public string AustralianBusinessNumberId { get; set; }

        /// <summary>
        /// Tax Agent Number (TAN)
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public string TaxAgentNumberId { get; set; }
    }
}
 
